(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var Accounts = Package['accounts-base'].Accounts;
var SandstormDb = Package['sandstorm-db'].SandstormDb;

/* Package-scope variables */
var SandstormAccountsMerge, promiseToFuture, waitPromise;

(function () {

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                      //
// packages/sandstorm-accounts-merge/accounts-merge-common.js                                           //
//                                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                        //
// Sandstorm - Personal Cloud Sandbox                                                                   // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                // 2
// All rights reserved.                                                                                 // 3
//                                                                                                      // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                      // 5
// you may not use this file except in compliance with the License.                                     // 6
// You may obtain a copy of the License at                                                              // 7
//                                                                                                      // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                         // 9
//                                                                                                      // 10
// Unless required by applicable law or agreed to in writing, software                                  // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                    // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                             // 13
// See the License for the specific language governing permissions and                                  // 14
// limitations under the License.                                                                       // 15
                                                                                                        // 16
SandstormAccountsMerge = {};                                                                            // 17
                                                                                                        // 18
//////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                      //
// packages/sandstorm-accounts-merge/accounts-merge-server.js                                           //
//                                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                        //
// Sandstorm - Personal Cloud Sandbox                                                                   // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                // 2
// All rights reserved.                                                                                 // 3
//                                                                                                      // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                      // 5
// you may not use this file except in compliance with the License.                                     // 6
// You may obtain a copy of the License at                                                              // 7
//                                                                                                      // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                         // 9
//                                                                                                      // 10
// Unless required by applicable law or agreed to in writing, software                                  // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                    // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                             // 13
// See the License for the specific language governing permissions and                                  // 14
// limitations under the License.                                                                       // 15
                                                                                                        // 16
var Future = Npm.require("fibers/future");                                                              // 17
                                                                                                        // 18
promiseToFuture = function (promise) {                                                                  // 19
  var result = new Future();                                                                            // 20
  promise.then(result.return.bind(result), result.throw.bind(result));                                  // 21
  return result;                                                                                        // 22
}                                                                                                       // 23
                                                                                                        // 24
waitPromise = function (promise) {                                                                      // 25
  return promiseToFuture(promise).wait();                                                               // 26
}                                                                                                       // 27
                                                                                                        // 28
Meteor.methods({                                                                                        // 29
  mergeWithAccount: function (token) {                                                                  // 30
    throw new Meteor.Error(400, "Accounts merging turned off for now. Needs more testing.");            // 31
                                                                                                        // 32
    check(token, String);                                                                               // 33
    if (!this.userId) {                                                                                 // 34
      throw new Meteor.Error(403, "Cannot merge accounts if not logged in.");                           // 35
    }                                                                                                   // 36
    var hashed = Accounts._hashLoginToken(token);                                                       // 37
    var winningUser = Meteor.users.findOne({"services.resume.loginTokens.hashedToken": hashed});        // 38
                                                                                                        // 39
    if (!winningUser) {                                                                                 // 40
      throw new Meteor.Error(404, "No account found for token: " + token);                              // 41
    }                                                                                                   // 42
                                                                                                        // 43
    var losingUser = Meteor.user();                                                                     // 44
                                                                                                        // 45
    if (losingUser.merging) {                                                                           // 46
      throw new Meteor.Error(400, "Account is already being merged.");                                  // 47
    }                                                                                                   // 48
                                                                                                        // 49
    // We need to verify that we can actually do the merge.                                             // 50
    // For now, this means that there is at most one instance of each service                           // 51
    // in the two identities arrays.                                                                    // 52
    var servicesPresent = {};                                                                           // 53
    function verifyUnique(service) {                                                                    // 54
      if (service in servicesPresent) {                                                                 // 55
        throw new Meteor.Error(400, "Cannot merge accounts with duplicate service: " + service);        // 56
      }                                                                                                 // 57
      servicesPresent[service] = true;                                                                  // 58
    }                                                                                                   // 59
    winningUser.identities.forEach(function(identity) {                                                 // 60
      verifyUnique(identity.service);                                                                   // 61
    });                                                                                                 // 62
    losingUser.identities.forEach(function(identity) {                                                  // 63
      verifyUnique(identity.service);                                                                   // 64
    });                                                                                                 // 65
                                                                                                        // 66
    // assert that there are no other pending merges?                                                   // 67
    Meteor.users.update(losingUser._id,                                                                 // 68
                        {$set: {merging: {destinationUserId: winningUser._id, status: "pending",        // 69
                                          sourceIdentities: losingUser.identities,                      // 70
                                          sourceServices: losingUser.services}},                        // 71
                         $unset: {identities: 1, services: 1}});                                        // 72
                                                                                                        // 73
  },                                                                                                    // 74
                                                                                                        // 75
  unmergeToAccount: function (destUserId) {                                                             // 76
    throw new Meteor.Error(400, "Accounts unmerging turned off for now. Needs more testing.");          // 77
                                                                                                        // 78
    check(destUserId, String);                                                                          // 79
    if (!this.userId) {                                                                                 // 80
      throw new Meteor.Error(403, "Cannot merge accounts if not logged in.");                           // 81
    }                                                                                                   // 82
    var sourceUser = Meteor.user();                                                                     // 83
    if (!sourceUser.mergedUsers || sourceUser.mergedUsers.indexOf(destUserId) == -1) {                  // 84
      throw new Meteor.Error(403, "Current user was never merged with user " + destUserId);             // 85
    }                                                                                                   // 86
                                                                                                        // 87
    // Now look up the destination user to figure out which identities and services                     // 88
    // to restore.                                                                                      // 89
                                                                                                        // 90
    var destUser = Meteor.users.findOne(destUserId);                                                    // 91
                                                                                                        // 92
    /// what if the status is still pending? Then we abort.                                             // 93
    var oldServices = destUser.merging && destUser.merging.status === "done" &&                         // 94
        destUser.merging.sourceServices;                                                                // 95
                                                                                                        // 96
    if (!oldServices) {                                                                                 // 97
      throw new Meteor.Error(400, "Cannot unmerge");                                                    // 98
    }                                                                                                   // 99
    var oldIdentities = {};                                                                             // 100
    var servicesToRemove = {};                                                                          // 101
    destUser.merging.sourceIdentities.forEach(function(identity) {                                      // 102
      oldIdentities[identity.id] = identity;                                                            // 103
      servicesToRemove["services." + identity.service] = 1;                                             // 104
    });                                                                                                 // 105
                                                                                                        // 106
    var sourceIdentities = sourceUser.identities.filter(function (identity) {                           // 107
      return identity.id in oldIdentities;                                                              // 108
    });                                                                                                 // 109
                                                                                                        // 110
    // TODO what about the case when there are multiple email identities                                // 111
    // in a single emailToken service?                                                                  // 112
                                                                                                        // 113
    // what about quota, login?                                                                         // 114
    Meteor.users.update(sourceUser._id,                                                                 // 115
                        {$set: {unmerging: {destinationUserId: destUserId, status: "pending",           // 116
                                            sourceIdentities: sourceIdentities,                         // 117
                                            sourceServices: oldServices}},                              // 118
                         $unset: servicesToRemove,                                                      // 119
                         $pull: {identities: {id: {$in: Object.keys(oldIdentities)}},                   // 120
                                 mergedUsers: destUserId} });                                           // 121
  }                                                                                                     // 122
});                                                                                                     // 123
                                                                                                        // 124
SandstormAccountsMerge.registerObservers = function (db, backend) {                                     // 125
  // TODO(before enabling merging): make these handlers robust to exceptions.                           // 126
                                                                                                        // 127
  Meteor.users.find({"merging.status": "pending"}).observe({                                            // 128
    added: function(losingUser) {                                                                       // 129
      console.log("merging user " + JSON.stringify(sourceUser));                                        // 130
      var winningUserId = losingUser.merging.destinationUserId;                                         // 131
      var winningUser = Meteor.users.findOne(winningUserId);                                            // 132
                                                                                                        // 133
      if (winningUser.mergedUsers.indexOf(losingUser._id) == -1) {                                      // 134
        // Now let's construct a modifier that will update the new user.                                // 135
        var fieldsToSet = {};                                                                           // 136
        var identitiesToPush = [];                                                                      // 137
        losingUser.merging.sourceIdentities.forEach(function(identity) {                                // 138
          identitiesToPush.push(identity);                                                              // 139
          if (identity.service === "dev") {                                                             // 140
            fieldsToSet.devName = losingUser.devName;                                                   // 141
          } else if (identity.service === "demo") {                                                     // 142
            fieldsToSet.expires = losingUser.expires;                                                   // 143
          } else if (identity.service === "github") {                                                   // 144
            fieldsToSet["services.github"] = losingUser.merging.sourceServices.github;                  // 145
          } else if (identity.service === "google") {                                                   // 146
            fieldsToSet["services.google"] = losingUser.merging.sourceServices.google;                  // 147
          } else if (identity.service === "emailToken") {                                               // 148
            fieldsToSet["services.emailToken"] = losingUser.merging.sourceServices.emailToken;          // 149
          }                                                                                             // 150
        });                                                                                             // 151
                                                                                                        // 152
        var modifier = {$push: {identities: {$each: identitiesToPush},                                  // 153
                                mergedUsers: losingUser._id}};                                          // 154
        if (Object.keys(fieldsToSet).length > 0) {                                                      // 155
          modifier["$set"] = fieldsToSet;                                                               // 156
        }                                                                                               // 157
        Meteor.users.update({_id: winningUserId}, modifier);                                            // 158
      }                                                                                                 // 159
                                                                                                        // 160
      db.collections.notifications.update({userId: losingUser._id},                                     // 161
                                          {$set: {userId: winningUserId}},                              // 162
                                          {multi: true});                                               // 163
                                                                                                        // 164
      db.collections.userActions.find({userId: losingUser._id}).forEach(function (action) {             // 165
        var newAction = _.omit(action, "_id");                                                          // 166
        newAction.userId = winningUserId;                                                               // 167
        db.collections.userActions.upsert({userId: winningUserId, packageId: action.packageId,          // 168
                                           title: action.title, nounPhrase: action.nounPhrase,          // 169
                                           command: action.command},                                    // 170
                                          {$set: newAction});                                           // 171
      });                                                                                               // 172
                                                                                                        // 173
      var grains = Grains.find({userId: losingUser._id}).fetch();                                       // 174
                                                                                                        // 175
      db.collections.grains.update({userId: losingUser._id},                                            // 176
                                   {$set: {userId: winningUserId}}, {multi: true});                     // 177
                                                                                                        // 178
      // Force all grains to shut down.                                                                 // 179
      grains.map(function (grain) {                                                                     // 180
        return backend.shutdownGrain(grain._id, losingUser._id, false);                                 // 181
      }).forEach(function (promise) {                                                                   // 182
        waitPromise(promise);                                                                           // 183
      });                                                                                               // 184
                                                                                                        // 185
      // Transfer grain storage to new owner.                                                           // 186
      // Note: We don't parallelize this because it can cause some contention in the Blackrock          // 187
      //   back-end.                                                                                    // 188
      // TODO(before enabling): make this robust to mid-transfer server crashes.                        // 189
      grains.forEach(function (grain) {                                                                 // 190
        return waitPromise(backend.cap().transferGrain(grain.userId, grain._id, winningUserId));        // 191
      });                                                                                               // 192
                                                                                                        // 193
      var result = Meteor.users.update(losingUser._id, {$unset: {devName: 1, expires: 1},               // 194
                                                        $set: {"merging.status": "done"}});             // 195
                                                                                                        // 196
    },                                                                                                  // 197
  });                                                                                                   // 198
                                                                                                        // 199
  Meteor.users.find({"unmerging.status": "pending"}).observe({                                          // 200
    added: function(sourceUser) {                                                                       // 201
      console.log("unmerging user " + JSON.stringify(sourceUser));                                      // 202
      var destUserId = sourceUser.unmerging.destinationUserId;                                          // 203
      var servicesSetter = {};                                                                          // 204
      for (var key in sourceUser.unmerging.sourceServices) {                                            // 205
        servicesSetter["services." + key] = sourceUser.unmerging.sourceServices[key];                   // 206
      }                                                                                                 // 207
                                                                                                        // 208
      var destUser = Meteor.users.findOne(destUserId);                                                  // 209
      if (destUser.merging) {                                                                           // 210
        Meteor.users.update(destUserId,                                                                 // 211
                            {$push: {identities: {$each: sourceUser.unmerging.sourceIdentities}},       // 212
                             $unset: {merging: 1},                                                      // 213
                             $set: servicesSetter});                                                    // 214
      }                                                                                                 // 215
                                                                                                        // 216
      var sourceIdentityIds = sourceUser.unmerging.sourceIdentities.map(function (x) { return x.id; }); // 217
                                                                                                        // 218
      var grains = Grains.find({userId: sourceUser._id, identityId: {$in: sourceIdentityIds}}).fetch(); // 219
                                                                                                        // 220
      db.collections.grains.update({userId: sourceUser._id, identityId: {$in: sourceIdentityIds}},      // 221
                                   {$set: {userId: destUserId}},                                        // 222
                                   {multi: true});                                                      // 223
                                                                                                        // 224
      // Force all grains to shut down.                                                                 // 225
      grains.map(function (grain) {                                                                     // 226
        return backend.shutdownGrain(grain._id, sourceUser._id, false);                                 // 227
      }).forEach(function (promise) {                                                                   // 228
        waitPromise(promise);                                                                           // 229
      });                                                                                               // 230
                                                                                                        // 231
      // Transfer grain storage to new owner.                                                           // 232
      // Note: We don't parallelize this because it can cause some contention in the Blackrock          // 233
      //   back-end.                                                                                    // 234
      // TODO(before enabling): make this robust to mid-transfer server crashes.                        // 235
      grains.forEach(function (grain) {                                                                 // 236
        return waitPromise(backend.cap().transferGrain(grain.userId, grain._id, destUserId));           // 237
      });                                                                                               // 238
                                                                                                        // 239
      var result = Meteor.users.update(sourceUser._id, {$unset: {"unmerging": 1}});                     // 240
    },                                                                                                  // 241
  });                                                                                                   // 242
                                                                                                        // 243
}                                                                                                       // 244
                                                                                                        // 245
//////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['sandstorm-accounts-merge'] = {
  SandstormAccountsMerge: SandstormAccountsMerge
};

})();

//# sourceMappingURL=sandstorm-accounts-merge.js.map
